'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = composeValidators;

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _lodash = require('lodash.omit');

var _lodash2 = _interopRequireDefault(_lodash);

var _createValidatorWithMultipleErrors = require('./createValidatorWithMultipleErrors');

var _createValidatorWithMultipleErrors2 = _interopRequireDefault(_createValidatorWithMultipleErrors);

var _createValidatorWithSingleError = require('./createValidatorWithSingleError');

var _createValidatorWithSingleError2 = _interopRequireDefault(_createValidatorWithSingleError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function composeValidators() {
  for (var _len = arguments.length, validators = Array(_len), _key = 0; _key < _len; _key++) {
    validators[_key] = arguments[_key];
  }

  return function configurableValidators(sharedConfig) {
    var config = undefined;

    if (typeof sharedConfig === 'string') {
      config = { field: sharedConfig };
    } else {
      config = (0, _objectAssign2.default)({}, sharedConfig);
    }

    if (config.multiple === true) {
      return (0, _createValidatorWithMultipleErrors2.default)(validators.slice(0), (0, _lodash2.default)(config, 'multiple'));
    }

    return (0, _createValidatorWithSingleError2.default)(validators.slice(0), config);
  };
}