'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createValidatorWithMultipleErrors;

var _configureValueValidator = require('./configureValueValidator');

function createValidatorWithMultipleErrors(validators, sharedConfig) {
  return function composedValidator(value) {
    return validators.reduce(function (errors, validator) {
      var errorMessage = undefined;

      if ((0, _configureValueValidator.isValueValidator)(validator)) {
        errorMessage = validator(value);
      } else {
        errorMessage = validator(sharedConfig, value);
      }

      if (errorMessage) {
        errors.push(errorMessage);
      }

      return errors;
    }, []);
  };
}