'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createValidatorWithSingleError;

var _configureValueValidator = require('./configureValueValidator');

function createValidatorWithSingleError(validators, sharedConfig) {
  return function composedValidator(value) {
    for (var i = 0, l = validators.length; i < l; i++) {
      var validator = validators[i];
      var errorMessage = undefined;

      if ((0, _configureValueValidator.isValueValidator)(validator)) {
        errorMessage = validator(value);
      } else {
        errorMessage = validator(sharedConfig, value);
      }

      if (errorMessage) {
        return errorMessage;
      }
    }
  };
}